#include "StdAfx.h"
#include "ComponentPropertyAccessor.h"
#include "ScriptletUtil.h"

BOOL ComponentPropertyAccessor::SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value)
{
	BOOL bSuccess = pTarget->SetProperty(property, value);
	if (bSuccess == TRUE) return bSuccess;

	USES_CONVERSION;
	//visible
	if (_tcsicmp(SCRIPTLET_VISIBLE_NODE, property) == 0)
	{
		BOOL bVisible = ScriptUtil::Varient2BOOL(&value);
		
		pTarget->SetVisible(bVisible);
		pTarget->GetParent()->RecalcLayout();
		pTarget->GetParent()->Invalidate();
	}
	//enabled
	else if (_tcsicmp(SCRIPTLET_ENABLED_NODE, property) == 0)
	{
		BOOL bEnabled = ScriptUtil::Varient2BOOL(&value);

		pTarget->EnableWindow(bEnabled);
		pTarget->Invalidate();
	}
	return bSuccess;
}
BOOL ComponentPropertyAccessor::GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value)
{
	BOOL bSuccess = pTarget->GetProperty(property, value);
	if (bSuccess == TRUE) return bSuccess;

	return bSuccess;
}